#include <QDateTime>

#include "floatimageobj.h"
#include "geometry.h"
#include "mapcenterobj.h"

/////////////////////////////////////////////////////////////////
// MapCenterObj
/////////////////////////////////////////////////////////////////
MapCenterObj::MapCenterObj() : BranchObj ()
{
//    cout << "Const MapCenterObj\n";
    init();
}

MapCenterObj::MapCenterObj(QGraphicsScene* s) : BranchObj (s)
{
//    cout << "Const MapCenterObj   canvas="<<s<<"\n";
    init();
}

MapCenterObj::~MapCenterObj() 
{
//    cout << "Destr MapCenterObj\n";
	clear();
}	

void MapCenterObj::clear() 
{
	BranchObj::clear();
}

void MapCenterObj::init () 
{
	BranchObj::init();
    orientation=LinkableMapObj::UndefinedOrientation;

	// TODO this should be done in TextObj later...
	//QFont font ("Sans Serif,16,-1,5,50,0,0,0,0,0");		
	//heading->setFont(font);
	//FIXME-2 no treeitem yet:  setDefAttr(MovedBranch); and already in BI::createMapObj ?!?

	frame->setFrameType (FrameObj::Rectangle);
}


void MapCenterObj::updateLink()
{
	// set childPos to middle of MapCenterObj
	childPos.setX( clickBox.topLeft().x() + (int)(clickBox.width())/2 );
	childPos.setY( clickBox.topLeft().y() + (int)(clickBox.height())/2 );
	parPos=childPos;		
	for (int i=0; i<treeItem->branchCount(); ++i)
		treeItem->getBranchObjNum(i)->updateLink();
}

void MapCenterObj::updateRelPositions()
{
	if (repositionRequest) unsetAllRepositionRequests();

	// update relative Positions of branches and floats
	for (int i=0; i<treeItem->branchCount(); ++i)
	{
		treeItem->getBranchObjNum(i)->setRelPos();
		treeItem->getBranchObjNum(i)->setOrientation();
	}
	
	for (int i=0; i<floatimage.size(); ++i)
		floatimage.at(i)->setRelPos();

	if (repositionRequest) reposition();
}

